#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <QGraphicsScene>
#include <QGraphicsLineItem>
#include <QGraphicsRectItem>
#include <QGraphicsSceneWheelEvent>

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
}

MainWindow::~MainWindow()
{
    delete ui;
}

class C : public QGraphicsRectItem
{
protected:
    void mousePressEvent (QGraphicsSceneMouseEvent * e)
    {
        setBrush(QColor ("green"));
        setToolTip("click");
    }

    void wheelEvent(QGraphicsSceneWheelEvent *e)
    {
        cnt += e->delta() / 4;
        setToolTip(QString::number(cnt));
        setBrush(QColor::fromHsv(abs (cnt % 360), 240, 240));
    }

private:
    int cnt;

public:
    C () : cnt (0) { }

};

void MainWindow::on_actionRun_triggered()
{
    QGraphicsScene * scene = new QGraphicsScene;
    ui->graphicsView->setScene(scene);

    scene->addLine(0, 0, 100, 100);

    QGraphicsRectItem * r = new C;
    r->setRect(0, 0, 20, 40);
    r->setPen(QPen (QColor ("red")));
    r->setBrush(QBrush (QColor ("yellow")));
    r->setFlag(QGraphicsItem::ItemIsMovable);
    scene->addItem (r);

}
